2 # SPDX-License-Identifier: EPL-1.0
3 ##############################################################################
4 # Copyright (c) 2017 The Linux Foundation and others.
6 # All rights reserved. This program and the accompanying materials
7 # are made available under the terms of the Eclipse Public License v1.0
8 # which accompanies this distribution, and is available at
9 # http://www.eclipse.org/legal/epl-v10.html
10 ##############################################################################
12 # TODO: Remove the if-statement once we have fully migrated to /opt/ciman
13 if [ -d "/opt/ciman/openstack-hot" ]; then
14 cd /opt/ciman/openstack-hot || exit 1
16 cd /builder/openstack-hot || exit 1
19 # shellcheck disable=SC1090
22 lf-activate-venv --python python3 \
25 python-openstackclient \
29 JOB_SUM=$(echo "$JOB_NAME" | sum | awk '{{ print $1 }}')
30 VM_NAME="$JOB_SUM-$BUILD_NUMBER"
32 OS_TIMEOUT=15 # Minutes to wait for OpenStack VM to come online
33 STACK_RETRIES=2 # Number of times to retry creating a stack before fully giving up
34 STACK_SUCCESSFUL=false
35 # seq X refers to waiting for X minutes for OpenStack to return
36 # a status that is not CREATE_IN_PROGRESS before giving up.
37 openstack limits show --absolute
38 openstack limits show --rate
39 echo "Trying up to $STACK_RETRIES times to create $STACK_NAME."
40 for try in $(seq $STACK_RETRIES); do
41 # shellcheck disable=SC1083
42 openstack stack create --timeout "$OS_TIMEOUT" -t {stack-template} -e "$WORKSPACE/opendaylight-infra-environment.yaml" --parameter "job_name=$VM_NAME" --parameter "silo=$SILO" "$STACK_NAME"
43 echo "$try: Waiting for $OS_TIMEOUT minutes to create $STACK_NAME."
44 for i in $(seq $OS_TIMEOUT); do
46 OS_STATUS=$(openstack stack show -f value -c stack_status "$STACK_NAME")
51 echo "Stack initialized on infrastructure successful."
56 reason=$(openstack stack show "$STACK_NAME" -f value -c stack_status_reason)
57 echo "ERROR: Failed to initialize infrastructure. Reason: $reason"
58 openstack stack resource list -n 25 "$STACK_NAME"
60 echo "Deleting stack and possibly retrying to create..."
61 openstack stack delete --yes "$STACK_NAME"
63 # after stack delete, poll for 10m to know when stack is fully removed
64 # the logic here is that when "stack show $STACK_NAME" does not contain $STACK_NAME
65 # we assume it's successfully deleted and we can break to retry
66 for j in $(seq 20); do
68 delete_status=$(openstack stack show "$STACK_NAME" -f value -c stack_status)
69 echo "$j: $delete_status"
70 if [[ $delete_status == "DELETE_FAILED" ]]; then
71 reason=$(openstack stack show "$STACK_NAME" -f value -c stack_status_reason)
72 echo "ERROR: Failed to delete $STACK_NAME. Reason: $reason"
74 # Abandon is not supported in Vexxhost so let's keep trying to
76 # echo "Stack delete failed, trying to stack abandon now."
77 # openstack stack abandon "$STACK_NAME"
78 echo "Deleting failed stack: $STACK_NAME"
79 openstack stack delete --yes "$STACK_NAME"
82 if ! openstack stack show "$STACK_NAME" -f value -c stack_status; then
83 echo "Stack show on $STACK_NAME came back empty. Assuming successful delete"
88 # If we still see $STACK_NAME in `openstack stack show` it means the delete hasn't fully
89 # worked and we can exit forcefully
90 if openstack stack show "$STACK_NAME" -f value -c stack_status; then
91 echo "Stack $STACK_NAME still in cloud output after polling. Quitting!"
97 echo "Waiting to initialize infrastructure."
101 echo "Unexpected status: $OS_STATUS"
102 # DO NOT exit on unexpected status. Rackspace sometimes returns unexpected status
103 # before returning an expected status. Just print the message and loop until we have
104 # a confirmed state or timeout.
109 if $STACK_SUCCESSFUL; then
114 # capture stack info in console logs
115 echo "------------------------------------"
117 echo "------------------------------------"
118 openstack stack show "$STACK_NAME" -f yaml
119 echo "------------------------------------"
121 if ! $STACK_SUCCESSFUL; then